﻿Imports Microsoft.SqlServer.Management.Common
Imports Microsoft.SqlServer.Management.Smo
Imports System.Data.SqlClient
Imports System.Windows.Forms
Imports System.Collections.Specialized



<ComClass(CSMO.ClassId, CSMO.InterfaceId, CSMO.EventsId)> _
Public Class CSMO

#Region "COM-GUIDs"
    ' Diese GUIDs stellen die COM-Identität für diese Klasse 
    ' und ihre COM-Schnittstellen bereit. Wenn Sie sie ändern, können vorhandene 
    ' Clients nicht mehr auf die Klasse zugreifen.
    Public Const ClassId As String = "83e0fda0-a692-4104-8389-c5e84962de02"
    Public Const InterfaceId As String = "1009a95f-a929-419a-b429-a6c6260d6d3b"
    Public Const EventsId As String = "02559fca-3788-4304-9636-427b9e769d4a"
#End Region

    Private smo_servername As String
    Private smo_username As String
    Private smo_password As String
    Private smo_loginsecure As Boolean
    Private frm As frmFortschritt

    ' Eine erstellbare COM-Klasse muss eine Public Sub New() 
    ' ohne Parameter aufweisen. Andernfalls wird die Klasse 
    ' nicht in der COM-Registrierung registriert und kann nicht 
    ' über CreateObject erstellt werden.
    Public Sub New()
        MyBase.New()
        smo_loginsecure = True   ' Standardanmeldung integrierte Sicherheit
    End Sub


    Public Function GetAllSQLServers() As String()
        Dim dt As DataTable = SmoApplication.EnumAvailableSqlServers(False)
        Dim res(dt.Rows.Count) As String
        Dim i As Integer

        MessageBox.Show(dt.Rows.Count.ToString())
        For i = 0 To dt.Rows.Count - 1
            res(i) = dt.Rows(i)(0).ToString()
            MessageBox.Show(dt.Rows(i)(0).ToString())
        Next

        Return res
    End Function

    Public Function GetAllDatabases() As String()
        ' Anmeldung festlegen
        Dim serv As New Server(smo_servername)
        If Not smo_loginsecure Then
            serv.ConnectionContext.LoginSecure = False
            serv.ConnectionContext.Login = smo_username
            serv.ConnectionContext.Password = smo_password
        End If

        Dim res As New StringCollection
        For Each db As Database In serv.Databases
            If db.IsSystemObject Then
                '
            Else
                res.Add(db.Name)
            End If
        Next db

        Dim arr(res.Count) As String
        res.CopyTo(arr, 0)
        Return arr
    End Function


    Public Function GetAllTables(databasename As String) As String()
        ' Anmeldung festlegen
        Dim serv As New Server(smo_servername)
        If Not smo_loginsecure Then
            serv.ConnectionContext.LoginSecure = False
            serv.ConnectionContext.Login = smo_username
            serv.ConnectionContext.Password = smo_password
        End If

        Dim db As Database
        db = serv.Databases(databasename)
        Dim res As New StringCollection
        Try
            For Each tbl As Table In db.Tables
                res.Add(tbl.Name)
            Next
        Catch
        End Try

        Dim arr(res.Count) As String
        res.CopyTo(arr, 0)
        Return arr
    End Function


    Public Function BackupDatabase(databasename As String, filename As String) As Boolean
        Dim res As Boolean = False
        ' Anmeldung festlegen
        frm = New frmFortschritt()
        frm.Show()
        Try
            Dim serv As New Server(smo_servername)
            If Not smo_loginsecure Then
                serv.ConnectionContext.LoginSecure = False
                serv.ConnectionContext.Login = smo_username
                serv.ConnectionContext.Password = smo_password
            End If
            Dim bck As New Backup()
            bck.Action = BackupActionType.Database
            bck.Database = databasename
            bck.Incremental = False ' inkrementell
            bck.Initialize = True ' überschreiben
            bck.PercentCompleteNotification = 10
            AddHandler bck.PercentComplete, AddressOf bck_PercentComplete
            AddHandler bck.Complete, AddressOf bck_Complete
            bck.Devices.Add(New BackupDeviceItem(filename, DeviceType.File))
            bck.SqlBackup(serv)
            res = True
        Catch ex As Exception
            MessageBox.Show(ex.Message)
        End Try
        frm.Close()
        frm.Dispose()
        Return res
    End Function

    Public Function RestoreDatabase(databasename As String, filename As String) As Boolean
        Dim res As Boolean = False
        ' Anmeldung festlegen
        frm = New frmFortschritt()
        frm.Show()
        Try
            Dim serv As New Server(smo_servername)
            If Not smo_loginsecure Then
                serv.ConnectionContext.LoginSecure = False
                serv.ConnectionContext.Login = smo_username
                serv.ConnectionContext.Password = smo_password
            End If

            Dim restore As New Restore()
            restore.Action = RestoreActionType.Database
            restore.Database = databasename
            AddHandler restore.PercentComplete, AddressOf bck_PercentComplete
            AddHandler restore.Complete, AddressOf bck_Complete
            restore.Devices.Add(New BackupDeviceItem(filename, DeviceType.File))
            restore.SqlRestore(serv)
            res = True
        Catch ex As Exception
            MessageBox.Show(ex.Message)
        End Try
        frm.Close()
        frm.Dispose()
        Return res
    End Function

    Private Sub bck_Complete(sender As Object, e As ServerMessageEventArgs)
        frm.ProgressBar1.Value = 0
    End Sub

    Private Sub bck_PercentComplete(sender As Object, e As PercentCompleteEventArgs)
        frm.ProgressBar1.Value = e.Percent
    End Sub


    Public WriteOnly Property ServerName As String
        Set(ByVal value As String)
            smo_servername = value
        End Set
    End Property

    Public WriteOnly Property UserName As String
        Set(ByVal value As String)
            smo_username = value
        End Set
    End Property

    Public WriteOnly Property Password As String
        Set(ByVal value As String)
            smo_password = value
        End Set
    End Property

    Public WriteOnly Property LoginSecure As Boolean
        Set(ByVal value As Boolean)
            smo_loginsecure = value
        End Set
    End Property

    Public Function Anzeige() As String
        Return " "
    End Function

End Class


