[Setup]
AppName=DOKO-Accessanwendung
AppVersion=47.11
AppCopyright=(c) 2013 Doberenz & Gewinnus
UninstallDisplayName=DOKO-Access-Anwendung
DefaultGroupName=DOKO-Access-App
DefaultDirName={pf}\DOKOAccessApp
AppPublisher=Doberenz & Gewinnus
AppPublisherURL=http://doko-buch.de
AppId={{20DAB17E-0DFD-4CD9-996C-E2FE59AE933F}
UninstallDisplayIcon={userappdata}\DOKO\16.ico
MinVersion=0,6.1


[Icons]
Name: "{group}\DOKO-Access-Beispielanwendung"; Filename: "{userappdata}\DOKO\Programm.mde"; IconFilename: "{userappdata}\DOKO\16.ico"

[Files]
Source: "C:\Arbeit\Access 2013 Grundlagen\CD\21 Techniken\Setup\Programm.mde"; DestDir: "{userappdata}\DOKO"
Source: "C:\Arbeit\Access 2013 Grundlagen\CD\21 Techniken\Setup\Daten.mdb"; DestDir: "{userappdata}\DOKO"; Flags: uninsneveruninstall
Source: "C:\Arbeit\Access 2013 Grundlagen\CD\21 Techniken\Setup\AccessRuntime\*"; DestDir: "{tmp}\AccessRT"; Flags: deleteafterinstall recursesubdirs createallsubdirs; Check: IsNoAccess2010
Source: "C:\Arbeit\Access 2013 Grundlagen\CD\21 Techniken\Setup\16.ico"; DestDir: "{userappdata}\DOKO"

[Run]
Filename: "{tmp}\AccessRT\AccessRuntime.exe"; StatusMsg: "Installing MS Access 2010 Runtime..."; Check: IsNoAccess2010
Filename: "{tmp}\AccessRT\accessruntime2010sp1-kb2460015-x86-fullfile-de-de.exe"; StatusMsg: "Installing MS Access 2010 Runtime SP1 ..."; Check: IsNoAccess2010

[Registry]
Root: "HKCU"; Subkey: "Software\Microsoft\Office\14.0\Access\Security\Trusted Locations\LocationDOKO"; ValueType: string; ValueName: "Path"; ValueData: "{userappdata}\DOKO"; Check: IsAccessVersion(14)
Root: "HKCU"; Subkey: "Software\Microsoft\Office\15.0\Access\Security\Trusted Locations\LocationDOKO"; ValueType: string; ValueName: "Path"; ValueData: "{userappdata}\DOKO"; Check: IsAccessVersion(15)

[Languages]
Name: en; MessagesFile: "compiler:Default.isl"
Name: de; MessagesFile: "compiler:Languages\German.isl"

[Code]
// 8.00.00.3512 Access 97 
// 8.00.00.4122 Access 97 SR1 
// 8.00.00.5903 Access 97 SR2 
// 9.00.00.2719 Access 2000 
// 9.00.00.3822 Access 2000 SR1 
// 9.00.00.4506 Access 2000 SR2 
// 10.00.2627.1 Access XP 
// 11.0.5614.0 Access 2003
// 11.0.5614.5703 Access 2003 Crit Update 1
// 12.0.4518.1014	Access 2007 
// 12.0.6211.1000	Access 2007 SP1
// 12.0.6423.1000 Access 2007 SP2
// 14.0.4750.1000 Access 2010
// 14.0.6024.1000 Access 2010 SP1
// 15 Access 2013

function GetAccessVersion(): Integer; 
var accversion, accpath: String; 
begin 
  accversion := '0.'; 
  if RegQueryStringValue(HKEY_LOCAL_MACHINE, 
      'SOFTWARE\Microsoft\Windows\CurrentVersion\App Paths\MSACCESS.EXE', 
      '', accpath) then begin 
    GetVersionNumbersString(accpath, accversion); 
  end; 
  if Copy(accversion,2,1) = '.' then accversion := Copy(accversion,1,1);
  Result := StrToInt(Copy(accversion,1,2));
end; 

function IsMinAccess2007(): boolean;
begin
   Result := GetAccessVersion()> 11; 
end;

function IsMinAccess2010(): boolean;
begin
   Result := GetAccessVersion()> 12; 
end;

function IsAccessVersion(Version: Integer): boolean;
begin
   Result := (GetAccessVersion() = Version); 
end;

function IsMinAccess2013(): boolean;
begin
   Result := GetAccessVersion()> 14; 
end;


function IsNoAccess2010(): boolean;
begin
   Result := NOT (GetAccessVersion()> 12); 
end;
